varying vec3 L,		// light position
			 N,		// normal vector
			 C;		// camera position

uniform sampler2D texDiffuse0,
				  texDiffuse1;

uniform float offset;

void main()
{
	vec3  R,			// reflected value
		  ct,			// total color day
		  IT;			// intensity total
	
	vec4 texelColor,		// texel from earth day texture
		 texelAlpha;
		 
	float I,			// light intensity
	      RL,			// rim lighting
	      S,			// specualar lighting
	      noise;		// noise for specular modulation
	   
	float localOffset = mod( offset, 1.0 );
		      
	// get all texture texels
	texelColor = texture2D( texDiffuse0, gl_TexCoord[0].st );	
	texelAlpha = texture2D( texDiffuse1, gl_TexCoord[0].st );		

	// calculate intensity value
	I = max( dot( L, N ), 0.0 );
	
	IT = ( I * gl_FrontMaterial.diffuse.rgb ) + gl_FrontMaterial.ambient.rgb;
	
	// calculate day and night final colors
	ct = ( texelColor.rgb + IT );
	
	// output final color and alpha
	gl_FragColor = vec4( ct, texelAlpha.r );	
}
