varying vec3 N,C;

uniform sampler2D texDiffuse0,
				  texDiffuse1,
				  texNoise;

uniform float offset;

void main()
{
	vec2 d1 = gl_TexCoord[0].st,
		 d2 = gl_TexCoord[0].st,
		 d3 = vec2(0.0);
		 
	vec3 noiseVec;
	
	vec4 texelColor,
		 texelSpots,
		 texelBlend;
		 
	float RL,
		  HS;

	float localOffset = mod( offset, 1.0 );
	
	d1.x += localOffset;
	d1.y += localOffset;
	
	d2.x -= localOffset;
	d2.y -= localOffset;	

	d3.x += localOffset;

	noiseVec = normalize( texture2D( texNoise, d1.xy ).xyz) +
			   normalize( texture2D( texNoise, d2.xy ).xyz);
	
	noiseVec *= noiseVec;
			     
	noiseVec = ( noiseVec * 2.0 - 1.0 ) * 0.035;
	
	texelColor = texture2D( texDiffuse0, gl_TexCoord[0].st + noiseVec.xy ) * vec4( 1.0, 1.0, 0.0, 1.0 );
	texelBlend = texture2D( texDiffuse0, gl_TexCoord[0].st - noiseVec.xy * 0.25 - d3 );
	texelSpots = 1.0 - texture2D( texDiffuse1, gl_TexCoord[0].st - noiseVec.xy * 0.25 + d3 );			

	RL = 1.0 - max( dot( C,  N ), 0.0 );
	RL *= RL;
	
	HS = ( clamp( texelBlend.r , 0.65, 1.0 ) - 0.65 ) * 3.0;

	gl_FragColor = vec4( clamp( texelColor.rgb + vec3( 1.0, 0.0, 0.0 ), 0.0, 1.0 ) + HS - texelSpots + RL, 1.0 );
}
