varying vec3 N,C;

uniform sampler2D texDiffuse0,
				  texDiffuse1,
				  texNoise;

uniform float offset;

void main()
{
	vec2 d1 = gl_TexCoord[0].st,
		 d2 = gl_TexCoord[0].st,
		 d3 = vec2(0.0);
		 
	vec3 noiseVec;
	
	vec4 texelColor;
		 
	float RL;

	float localOffset = mod( offset, 1.0 ) * 4.0;
	
	d1.x += localOffset;
	d1.y += localOffset;
	
	d2.x -= localOffset;
	d2.y -= localOffset;

	noiseVec = normalize( texture2D( texNoise, d1.xy ).xyz) +
			   normalize( texture2D( texNoise, d2.xy ).xyz);
	
	noiseVec *= noiseVec;
			     
	noiseVec = ( noiseVec * 2.0 - 1.0 )* 0.035;
	
	texelColor = texture2D( texDiffuse0, gl_TexCoord[0].st + noiseVec.xy );

	RL = clamp( pow( max( dot( C,  N ), 0.0 ), 5.0 ), 0.0, 1.0 );

	gl_FragColor = vec4( vec3( 1.0, 0.75, 0.25 ), clamp( RL, 0.0, 1.0 ) );
}
